<template>
  <v-container
    style="height: 100%"
    fluid
  >
    <base-searchbar
      :filter-by="filterList"
      :filter-count="1"
      title="Tags"
      icon="mdi-tag-text"
      show-add-filter
      @trigger="$trigger"
      @refresh="bootstrap"
    >
      <template v-slot:body>
        <v-btn
          color="primary"
          @click="modals.createTag.status = true"
        >
          <v-icon>mdi-plus</v-icon>
        </v-btn>
      </template>
    </base-searchbar>

    <v-card>
      <v-data-table
        :headers="tagHeader"
        :items="tagsList"
        class="elevation-1"
        :loading="dataStatus.tagsTable.loading"
      >
        <template #item.actions="{ item }">
          <v-btn
            small
            color="primary"
            class="mr-1"
            @click="handleClickModifyTag({ item })"
          >
            Edit
          </v-btn>

          <v-btn
            v-if="!item.deleted_at"
            small
            color="red white--text"
            @click="handleClickDeleteTag({ item })"
          >
            Delete
          </v-btn>

          <v-btn
            v-if="item.deleted_at"
            small
            color="blue"
            @click="handleClickRestoreTag({ item })"
          >
            Restore
          </v-btn>
        </template>
      </v-data-table>
    </v-card>

    <!-- create tag -->
    <base-modal
      v-model="modals.createTag.status"
      title="create tag"
      @trigger="handleTriggerCreateTag"
    >
      <template #body>
        <v-text-field
          v-model="modals.createTag.data.tag"
          label="Tag*"
          outlined
          required
        />

        <v-textarea
          v-model="modals.createTag.data.definition"
          label="Definition*"
          outlined
          required
        />
      </template>
    </base-modal>

    <!-- modify tag -->
    <base-modal
      v-model="modals.modifyTag.status"
      title="modify tag"
      @trigger="handleTriggerModifyTag"
    >
      <template #body>
        <v-text-field
          v-model="modals.modifyTag.data.tag"
          label="Tag*"
          outlined
          required
        />

        <v-textarea
          v-model="modals.modifyTag.data.definition"
          label="Definition*"
          outlined
          required
        />
      </template>
    </base-modal>
  </v-container>
</template>

<script>
// eslint-disable-next-line no-unused-vars
import { mapActions, mapGetters, mapState } from 'vuex'

export default {
  name: 'AdminTags',

  data: () => ({
    filterList: ['Name', 'Definition'],

    tagHeader: [
      { text: 'ID', value: 'tag_id', width: 100 },
      { text: 'Name', value: 'name' },
      { text: 'Definition', value: 'definition' },
      { text: 'Actions', value: 'actions', width: 200 }
    ],

    dataStatus: {
      tagsTable: { loading: true }
    },

    modals: {
      createTag: {
        status: false,
        data: {
          tag: '',
          definition: ''
        },
        reset () {
          this.data.tag = ''
          this.data.definition = ''
        }
      },
      modifyTag: {
        status: false,
        data: {
          tag_id: '',
          tag: '',
          definition: ''
        },
        reset () {
          this.data.tag = ''
          this.data.definition = ''
        }
      }
    }
  }),

  computed: {
    ...mapState('tags', {
      tagsList: 'tags'
    })
  },

  watch: {
    $route: {
      async handler (data) {
        await this.bootstrap({ ...data.query })
      },

      immediate: true
    }
  },

  created () {
    this.bootstrap()
  },

  methods: {
    ...mapActions('tags', {
      getTagsList: 'getTagsList',
      createTag: 'createTag',
      modifyTag: 'modifyTag',
      deleteTag: 'deleteTag',
      restoreTag: 'restoreTag'
    }),

    bootstrap (payload) {
      const config = {
        loading: 'dataStatus.tagsTable.loading'
      }

      this.statusWrapper(async () => {
        await this.getTagsList({ ...this.$route.query, ...payload })
      }, config)
    },

    async handleTriggerCreateTag () {
      const modal = this.modals.createTag

      try {
        await this.createTag(modal.data)
        await this.bootstrap()

        this.$setAlert({ type: 'success' })

        modal.status = false
        modal.reset()
      } catch (error) {
        this.$handleError(error)
      }
    },

    handleClickModifyTag ({ item }) {
      const modal = this.modals.modifyTag

      modal.data.tag_id = item.tag_id
      modal.data.tag = item.name
      modal.data.definition = item.definition
      modal.status = true
    },

    async handleTriggerModifyTag () {
      const modal = this.modals.modifyTag

      try {
        await this.modifyTag(modal.data)
        await this.bootstrap()

        this.$setAlert({ type: 'success' })

        modal.status = false
        modal.reset()
      } catch (error) {
        this.$handleError(error)
      }
    },

    handleClickDeleteTag ({ item }) {
      const success = async () => {
        try {
          await this.deleteTag({ tag_id: item.tag_id })

          this.$setAlert({ type: 'success' })

          await this.bootstrap()
        } catch (error) {
          this.$handleError(error)
        }
      }

      return this.$prompt({ success })
    },

    handleClickRestoreTag ({ item }) {
      const success = async () => {
        try {
          await this.restoreTag({ tag_id: item.tag_id })

          this.$setAlert({ type: 'success' })

          await this.bootstrap()
        } catch (error) {
          this.$handleError(error)
        }
      }

      return this.$prompt({ success })
    }

  }
}
</script>
